// Quick demo put together by Groomblecom (Groomblecom@gmail.com, groomble.com)
// If you want to use this example outside processing, then make Timer for calling draw() and replace PVector with a vector class of your own choosing. I recomend javax.vecmath for compatability reasons, but there are planty of math libraries out there.
// remember that Timers must be set to repeat.
// processing's drawing system is very similar to Graphics2D in javax.swing, so that would be my bet for a non-processing implementation.
// This implementation is far from perfect: Stacks will vibrate and such.

final float GRAVITY = 0.01; // keep it small, because it's applied every tick- at 60 TPS.

ArrayList<Box> boxes = new ArrayList<Box>();
boolean step = false;
boolean quick = false;

void setup() {
  size(800, 600);
  frameRate(60);
  strokeWeight(2);
  strokeCap(PROJECT);
  stroke(0);
  boxes.add(new Box(new PVector(0, 500), new PVector(2, 0))); // Vel is applied 60 times a second, here, so keep it small or beware. This demo uses discrete detection, which means that not only will things collide wierdly at high speeds, they'll even 'ghost' through.
  boxes.add(new Box(new PVector(600, 530), false)); // remember, coordinates of _upper_ _left_
  boxes.add(new Box(new PVector(400, 160)));
}

void draw() {
  background(255);
  for(int i = 0; i < boxes.size(); i++) {
    boxes.get(i).update();
  }
  for(int i = 0; i < boxes.size(); i++) {
    boxes.get(i).satisfyConstraints();
  }
  for(int i = 0; i < boxes.size(); i++) {
    boxes.get(i).applySolution();
  }
  for(int i = 0; i < boxes.size(); i++) {
    boxes.get(i).display();
  }
}

void mouseReleased() {
  if(mouseButton==39){
    if(!step) {noLoop();}else{loop();}
    step = !step;
    return;
  }
  if(mouseButton==3) {
    println(boxes.get(0).pos+" "+boxes.get(0).vel);
    return;
  }
  if(!step) {
    if(quick) {
      frameRate(120);
    }else{
      frameRate(60);
    }
    quick = !quick;
  }
  redraw();
}
